﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.9
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Public Mode As String
	Public Customer As B4XCustomerPage
	
	Private ToastMessage As BCToast
	Private Edit As PageEdit
	Private edtName, edtDescription, edtAdress1, edtAdress2, edtAdress3, edtStreet, edtTown As B4XView
	Private lblRowID As B4XView
	Private btnAdd, btnDelete, btnUpdate, btnPrevious, btnNext, btnFirst, btnLast As B4XView
End Sub

'You can add more parameters here.
Public Sub Initialize

End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("Edit")
	ToastMessage.Initialize(Root)
End Sub

Private Sub B4XPage_Appear
	ShowEntry(B4XPages.MainPage.Customer.CurrentIndex)
	
End Sub

Private Sub btnMove_Click
	Private btn As Button
	Private Tag As String
	
	btn = Sender
	Tag = btn.Tag

	Select Tag
		Case "First"
			B4XPages.MainPage.CurrentIndex = 0
		Case "Prev"
			B4XPages.MainPage.CurrentIndex = Max(0, B4XPages.MainPage.CurrentIndex - 1)
		Case "Next"
			B4XPages.MainPage.CurrentIndex = Min(B4XPages.MainPage.CurrentIndex + 1, B4XPages.MainPage.RowIDList.Size - 1)
		Case "Last"
			B4XPages.MainPage.CurrentIndex = B4XPages.MainPage.RowIDList.Size - 1
	End Select
	ShowEntry(B4XPages.MainPage.CurrentIndex)
End Sub

Private Sub btnAdd_Click
	If AddEntry = True Then
		Edit.Mode = "Edit"
		ShowButtons
	End If
End Sub

Private Sub btnDelete_Click
	DeleteEntry
End Sub

Private Sub btnUpdate_Click
	UpdateEntry
End Sub

Public Sub ShowEntry(EntryIndex As Int)
	Private RowID As Int
	
	If B4XPages.MainPage.Customer.RowIDList.Size = 0 Then 			'check if the database is empty
		Return											'if yes leave the routine
	End If
	
	If Edit.Mode = "Add" Then
		lblRowID.Text = ""
		edtName.Text = ""
		edtDescription.Text = ""
		edtAdress1.Text = ""
		edtAdress2.Text = ""
		edtAdress3.Text = ""
		edtStreet.Text = ""
		edtTown.Text = ""
	Else
		Private ResultSet1 As ResultSet
		RowID = B4XPages.MainPage.RowIDList.Get(EntryIndex)		'get the ID for the given entry index
		'read the entry with the given ID
		ResultSet1 = B4XPages.MainPage.SQL1.ExecQuery("SELECT * FROM customers WHERE rowid = " & RowID)
		lblRowID.Text = "  " & RowID													'display the ID
		ResultSet1.NextRow																		'set the cursor
		edtName.Text = ResultSet1.GetString("Name")	'read the value of the FirstName column
		edtDescription.Text = ResultSet1.GetString("Description")		'read the value of the LasstName column
		edtAdress1.Text = ResultSet1.GetString("Adress1")						'read the value of the City column
		edtAdress2.Text = ResultSet1.GetString("Adress2")						'read the value of the City column
		edtAdress3.Text = ResultSet1.GetString("Adress3")						'read the value of the City column
		edtStreet.Text = ResultSet1.GetString("Street")						'read the value of the City column
		edtTown.Text = ResultSet1.GetString("Town")						'read the value of the City column
		ResultSet1.Close																			'close the cursor, we don't it anymore
	End If
	ShowButtons
End Sub

Sub AddEntry As Boolean
	Private Query As String
	Private ResultSet1 As ResultSet
	Private RowID As Int
	
	'check if all dields are filled
	If edtName.Text = "" Or edtDescription.Text = "" Or edtAdress1.Text  = "" Then
		ToastMessage.Show("Missing data")	' confirmation for the user
		Return False
	End If
	
	'first we check if the entry already does exist
	Query = "SELECT * FROM customers WHERE Name = ? AND Description = ? AND Adress1 = ?"
	ResultSet1 = B4XPages.MainPage.Customer.SQL1.ExecQuery2(Query, Array As String (edtName.Text, edtDescription.Text, edtAdress1.Text))

	If ResultSet1.NextRow = True Then
		'if it exists show a message and do nothing else
		ToastMessage.Show("This entry already exists")
		ResultSet1.Close								'close the cursor, we don't it anymore
		Return False
	Else
		'if not, add the entry
		'we use ExecNonQuery2 because it's easier, we don't need to take care of the data types
		Query = "INSERT INTO customers VALUES (?, ?, ?, ?, ?, ?, ?)"
		B4XPages.MainPage.Customer.SQL1.ExecNonQuery2(Query, Array As String(edtName.Text, edtDescription.Text, edtAdress1.Text, edtAdress2.Text, edtAdress3.Text, edtStreet.Text, edtTown.Text))
	
		ToastMessage.Show("Entry added")	' confirmation for the user
	
		'to display the ID of the last entry we read the max value of the ID column
		RowID = B4XPages.MainPage.Customer.SQL1.ExecQuerySingleResult("SELECT max(rowid) FROM customers")
		B4XPages.MainPage.Customer.RowIDList.Add(RowID)			'add the last ID to the list
		B4XPages.MainPage.Customer.CurrentIndex = B4XPages.MainPage.Customer.RowIDList.Size - 1		'set the current index to the last one
		lblRowID.Text = RowID					'display the last index
	End If
	ResultSet1.Close								'close the cursor, we don't it anymore
	Return True
End Sub

Private Sub DeleteEntry
	Private Query As String
	
	'ask the user for confirmation
	Private sf As Object = xui.Msgbox2Async("Do you really want to delete " & edtName.Text & " " & edtDescription.Text, "Delete entry", "Yes", "", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		Query = "DELETE FROM customers WHERE rowid = " & B4XPages.MainPage.RowIDList.Get(B4XPages.MainPage.CurrentIndex)
		B4XPages.MainPage.SQL1.ExecNonQuery(Query)									'delete the entry
		B4XPages.MainPage.RowIDList.RemoveAt(B4XPages.MainPage.CurrentIndex)							'remove the ID from the list
		If B4XPages.MainPage.CurrentIndex = B4XPages.MainPage.RowIDList.Size Then			'if the current index is the last one
			B4XPages.MainPage.CurrentIndex = B4XPages.MainPage.CurrentIndex - 1					'decrement it by 1
		End If
		ShowEntry(B4XPages.MainPage.CurrentIndex)										'show the next entry
		ToastMessage.Show("Entry deleted")	'confirmation for the user
		ShowButtons
	End If
End Sub

Private Sub UpdateEntry
	Private Query As String
	
	Query = "UPDATE customers Set Name = ?, Description = ?, Adress1 = ?, Adress2 = ?, Adress3 = ?, Street = ?, Town = ? WHERE rowid = " & B4XPages.MainPage.RowIDList.Get(B4XPages.MainPage.CurrentIndex)
	B4XPages.MainPage.SQL1.ExecNonQuery2(Query, Array As String(edtName.Text, edtDescription.Text, edtAdress1.Text, edtAdress2.Text, edtAdress3.Text, edtStreet.Text, edtTown.Text))
	ToastMessage.Show("Entry updated")
End Sub

Private Sub ShowButtons
	If Edit.Mode = "Add" Then
		btnPrevious.Visible = False		'hide the navigation buttons
		btnNext.Visible = False
		btnFirst.Visible = False
		btnLast.Visible = False
		btnDelete.Visible = False
		btnUpdate.Visible = False
	Else
		btnDelete.Visible = True
		btnUpdate.Visible = True
		If B4XPages.MainPage.RowIDList.Size <= 1 Then 	'check if the database has less than 2 entries
			btnPrevious.Visible = False					'hide the navigation buttons
			btnNext.Visible = False
			btnFirst.Visible = False
			btnLast.Visible = False
		Else
			'show or hide the Previous and Next buttons depending on the value of the current index
			If B4XPages.MainPage.CurrentIndex = 0 Then
				btnPrevious.Visible = False
				btnFirst.Visible = False
			Else
				btnPrevious.Visible = True
				btnFirst.Visible = True
			End If
			
			If B4XPages.MainPage.CurrentIndex = B4XPages.MainPage.RowIDList.Size - 1 Then
				btnNext.Visible = False
				btnLast.Visible = False
			Else
				btnNext.Visible = True
				btnLast.Visible = True
			End If
		End If
	End If
End Sub
